<?PHP
class c_auftragsschein extends yadev4php_controller {


  public function init() {

  }
  

  public function main() {

	 $this->add_model('ticket','beauftragung',false,true,'id='.(int)$_GET['id']);
	 $this->add_model('lieferant','',false,true,'id='.'0'.$this->beauftragung->fk_lieferant);
	 $this->add_model('objekt','',false,true,'id='.$this->beauftragung->fk_objekt);
	 $this->add_model('anwender','verantwortlicher',false,true,'id='.$this->objekt->fk_objektverantwortlicher);
	 $this->add_model('anwender','werkmeister',false,true,'id='.$this->beauftragung->fk_werkmeister);

	 $werkmeister = $this->werkmeister->zuname." ".$this->werkmeister->vorname;

	 // Wenn noch keine Vorlage geladen wurdem dann jetzt nachholen!
	 if ($this->beauftragung->auftragsschein == '') {
	   $ts = $this->beauftragung->_db->dateToDb(Date('d.m.Y',time()));
	   $this->add_model('vorlage','',false,true,"ab_datum <= '".$ts."'","ab_datum desc");
	   $atext = $this->vorlage->auftragsschein;

	   $feld = array('#beauftragungstext#',
					 '#strasse#',
					 '#plz#',
					 '#ort#',
					 '#objektverantwortlicher#',
					 '#telefon#',
					 '#werkmeister#');
	   $wert = array($this->beauftragung->beauftragungstext, 
					 $this->objekt->strasse, 
					 $this->objekt->plz, 
					 $this->objekt->ort,
					 $this->verantwortlicher->vorname.' '.$this->verantwortlicher->zuname,
					 $this->objekt->telefon,
					 $werkmeister);

	   $atext = str_ireplace($feld, $wert, $atext);

	   $this->beauftragung->auftragsschein = $atext;
	   $this->beauftragung->wm = $werkmeister;
	   $this->beauftragung->updateModel();
	 }
	 // Template für Kopf- und Fu?bereich laden...
	 $this->views['view_1'] = new yadev4php_view();
//	 $this->views['view_1']->loadTPL("auftragsschein_edit.tpl");
	 $this->views['view_1']->loadTPL("auftragsschein_edit.tpl");
	 $this->views['view_1']->sendTPL();

  }
  
  
  public function save() {
  
	if ($_SERVER['REQUEST_METHOD'] != "POST") {
	  $this->main();
	  die();
	}

	$this->add_model('ticket','beauftragung',false,true,"id = ".(int)$_REQUEST['id']);
	$this->add_model('lieferant','',false,true,'id='.'0'.$this->beauftragung->fk_lieferant);
	$this->add_model('objekt','',false,true,'id='.$this->beauftragung->fk_objekt);

	if ($this->beauftragung->valid) {

	  $this->views['view_1'] = new yadev4php_view();
	  $this->views['view_1']->loadTPL("auftragsschein_edit.tpl");
	  $this->views['view_1']->readInput();

	  $this->beauftragung->auftragbearbeitet = true;

	  $this->beauftragung->updateModel();
	
	  $this->views['view_1']->sendTPL();
	}
	else echo "Error!";
  }
  
  

}
?>