<?PHP

class c_info extends yadev4php_controller {


  /* ---------------------------------------------------------------------------
  ----------------------------------------------------------------------------*/
  public function createWhere() {
  
    if ($_GET['sname'] != ""  && $_GET['AjaxRequestUniqueId'] == "") {
      $this->suche->loadModelByWhere("anwender=".$_SESSION['userid']." and titel like '".$_GET['sname']."'");
      $this->suche->suchstring = $_SERVER['QUERY_STRING'];
      $this->suche->titel = $_GET['sname'];
      $this->suche->art = "info";
      $this->suche->anwender = $_SESSION['userid'];
      if ($this->suche->valid == true)
        $this->suche->updateModel();
      else
        $this->suche->insertModel();
      $this->suche->loadModelByWhere("anwender=".$_SESSION['userid']." and art='info'");
    }


    $flt_fields = Array('aufgabe.lnummer',
                        'aufgabe.ersteller',
                        'aufgabe.erstell_datum',
                        'aufgabe.termin',
                        'aufgabe.letzte_aenderung',
                        'aufgabe.titel',
                        'aufgabe.besch',
                        'herkunft.kurz',
                        'status.kurz');
                        
    $flt_relations = Array('like',
                           '=',
                           '<',
                           '>',
                           '!=',
                           '<=',
                           '>=');
    $c = 0;
    $w = " and art=2";
    if (isset($_GET['flt_feld'])) {
      foreach ($_GET['flt_feld'] as $feld) {
        $value = $_GET['flt_value'][$c];

        if ($value == '#heute#') $value = Date('d.m.Y',time());
        if ($value == '#abteilung#') $value = $_SESSION['abteilung_kurz'];
        
        if (preg_match('/^(\d{2})\.(\d{2})\.(\d{4})$/', $value, $hits))
          $value = $hits[3]."-".$hits[2]."-".$hits[1];

        if ($_GET['flt_relation'][$c] == 0)
          $proz = "%";
        else
          $proz = "";
        $w .= " and (".$flt_fields[$feld]." ".$flt_relations[$_GET['flt_relation'][$c]]." '".$proz.$value.$proz."')";
        $c++;
      }
    }
    return $w;

  }

  /* ---------------------------------------------------------------------------
  ----------------------------------------------------------------------------*/
  public function init() {
  // Initialisierung fr main() und save()...
  
    // alle bentigten Modelle laden...
    $this->add_model("aufgabe","",true,true,"id = ".(int)$_REQUEST['id']);
    $this->add_model("status","",true,true);
    $this->add_model("herkunft","",true,true,"","kurz");


    // Template fr Kopf- und Fubereich laden...
    $this->views['view_1'] = new yadev4php_view();
    $this->views['view_1']->loadTPL("head.tpl","head");
    $this->views['view_1']->loadTPL("bottom.tpl","bottom");

  }
  
  
  /* ---------------------------------------------------------------------------
  ----------------------------------------------------------------------------*/
  public function _tooltip() {
    $this->add_model("aufgabe","",true,true,"id = ".(int)$_REQUEST['id']);
    echo nl2br(htmlentities($this->aufgabe->besch));
  }

  
  /* ---------------------------------------------------------------------------
  ----------------------------------------------------------------------------*/
  public function _list() {
  // Liste zur Auswahl anzeigen...
  
  
    $page = (INT)$_GET['page'];

    // Templates laden...
    $this->views['view_1'] = new yadev4php_view();
    if ($page == 0) {
      $this->views['view_1']->loadTPL("head.tpl","head");
      $this->views['view_1']->loadTPL("bottom.tpl","bottom");
    }
    $this->views['view_1']->loadTPL("info_list.tpl");

    // alle bentigten Modelle laden...
    $this->add_Model("suche","",true,true,"anwender=".$_SESSION['userid']." and art='info'");
    $this->add_model("aufgabe","",true);
    $this->add_model("status");
    $this->add_model("herkunft");
    $this->add_model("myjoin","join",false,false);
    
    // Join laden...
    $this->join->addModel($this->aufgabe);
    $this->join->addModel($this->herkunft,
                          "aufgabe.herkunft = herkunft.id",
                          "left join");
    $this->join->addModel($this->status,
                          "aufgabe.status = status.id",
                          "left join");


    $where = $this->createWhere();
    
    if ($_GET['page'] != "") {
      $page = $page - 1;

      echo "<hr>Start Select:".microtime(true);

      $this->join->loadModelByWhere("((status > 1) or (auftraggeber = ".$_SESSION['abteilung_id']."))".$where,"aufgabe.id",$page,150);

      echo "<hr>End Select:".microtime(true);

    }
    // Template anzeigen...

    $this->views['view_1']->sendTPL();

    if (count($this->join->_result) == 0) {
      if ($_GET['page'] != "") {
        echo "<fertig>";
        $top = 0;
        $prozent = 100;
        echo "<prozent><div style='position:absolute; width:100px; height:".$prozent."px; top:".$top."px; left:0px; background-color:green; text-align:center; color:white; text-decoration:bold;'>".$prozent."%<br><br>formatiere und sortiere Tabelle</div></prozent>";
      }
    }
    else {
      $numpages = ($this->join->numRecords/150)+0.99;
      $numpages = (INT)$numpages;
      $prozent = 100 / $numpages;
      $prozent = $prozent * ($page + 1);
      $prozent = (INT)$prozent;
      $top = 100 - $prozent;

      if ($_GET['page'] != "") {
        echo "<prozent><div style='position:absolute; width:100px; height:".$prozent."px; top:".$top."px; left:0px; background-color:green; text-align:center; color:white; text-decoration:bold;'>".$prozent."%</div></prozent>";
        echo "<hr>ende:".microtime(true);
      }
    }

  }
  
/* ---------------------------------------------------------------------------
----------------------------------------------------------------------------*/


  public function _export() {
  // Liste nach Excel exportieren...

    header("content-type: application/vnd.ms-excel");
    header("content-disposition: attachment; filename=Infos.xls");

    // Templates laden...
    $this->views['view_1'] = new yadev4php_view();
    $this->views['view_1']->loadTPL("head_export.tpl","head");
    $this->views['view_1']->loadTPL("bottom_export.tpl","bottom");
    $this->views['view_1']->loadTPL("info_export.tpl");

    // alle bentigten Modelle laden...
    $this->add_Model("suche","",true,true,"anwender=".$_SESSION['userid']." and art='info'");
    $this->add_model("aufgabe","",true);
    $this->add_model("status");
    $this->add_model('herkunft');
    $this->add_model("yadev4php_join","join",false,false);

    // Join laden...
    $this->join->addModel($this->aufgabe);
    $this->join->addModel($this->herkunft,
                          "aufgabe.herkunft = herkunft.id",
                          "left join");

    $where = $this->createWhere();
    $this->join->loadModelByWhere("1=1 ".$where);

    // Template anzeigen...
    $this->views['view_1']->sendTPL();
    die();
  }

  /* ---------------------------------------------------------------------------
  ----------------------------------------------------------------------------*/
  public function main() {
  // Datensatz anzeigen....


     // Wenn Datensatz gefunden wurde,
     // dann passendes Template auswhlen...
     if ($this->aufgabe->valid) {
       if ($_SESSION['darf_anlegen'])
         $this->views['view_1']->loadTPL("info_bearbeiten.tpl");
         //$this->views['view_1']->loadTPL("info_anlegen.tpl");
       else
         $this->views['view_1']->loadTPL("info_anzeigen.tpl");
     }
     else {
       if ($_SESSION['darf_anlegen']) {
         $this->views['view_1']->loadTPL("info_anlegen.tpl");
       } 
       else {
         // keine Berchtigung neue Datenstze anzulegen....
         $this->_list();
         die();
       }  
     }

     // gehltes Template anzeigen...
     $this->views['view_1']->sendTPL();

  }
  
  /* ---------------------------------------------------------------------------
  ----------------------------------------------------------------------------*/
  public function save() {
  // Speichere die Eingaben...

    // Wenn kein POST dann nur Model anzeigen....
    if ($_SERVER['REQUEST_METHOD'] != "POST") {
      $this->main();
      die();
    }
    
    

    // Wenn bestehnder Datensatz bearbeitet wurde,
    // das passende Template auswhlen...
    if ($this->aufgabe->valid)
      $this->views['view_1']->loadTPL("info_bearbeiten.tpl");
    else
      $this->views['view_1']->loadTPL("info_anlegen.tpl");

    // Client Eingaben verarbeiten
    $this->views['view_1']->readInput();
    

    // Wert fr letzte nderung setzten...
    $this->aufgabe->letzte_aenderung = date('d.m.Y',time());
    $this->aufgabe->art = 2;

    If ($_POST['b_submit2'] != "") {
      $this->aufgabe->status = 2;
    }

    If ($_POST['b_submit3'] != "") {
      $this->aufgabe->art = 1;
      $this->aufgabe->status = 1;
    }

    if ($this->aufgabe->valid) {
      $this->aufgabe->updateModel();     // Update des Datensatzes
      $this->views['view_1']->message = "Die &Auml;nderungen wurden gespeichert...";
    }
    // oder Neuanlage
    else {
      $this->aufgabe->status = 1;
      If ($_POST['b_submit2'] != "") {
        $this->aufgabe->status = 2;
      }
      $this->aufgabe->auftraggeber = $_SESSION['abteilung_id'];
      $this->aufgabe->lnummer = $this->aufgabe->get_ID();
      $this->aufgabe->groupid = $this->aufgabe->lnummer;
      $this->aufgabe->insertModel();     // Datensatz neu anlegen
      $this->views['view_1']->message = "Die Info wurde angelegt...";
    }


    // Passendes Template auswhlen...
     if ($_SESSION['darf_anlegen'])
       if ($this->aufgabe->art == 1) {
         $this->views['view_1']->loadTPL("info_weiterleitung.tpl");
       }
       else {
         $this->views['view_1']->loadTPL("info_bearbeiten.tpl");
       }
//       $this->views['view_1']->loadTPL("info_anlegen.tpl");
     else
       $this->views['view_1']->loadTPL("info_anzeigen.tpl");

    // und Template anzeigen
    $this->views['view_1']->sendTPL();

  }


}

?>
