<?
class anwender extends yadev4php_model {

  // define Customer Properties
  /** type:integer, index:primaryKey, value:auto */
  protected $id;
  /** type:String, size:255, validate:notNull(), logging:true */
  protected $vorname;
  /** type:String, size:255, validate:notNull(), logging:true */
  protected $zuname;
  /** type:String, size:255, validate:notNull(), logging:true */
  protected $email;
  /** type:String, size:255, logging:true */
  protected $telefon;
  /** type:String, size:255, validate:notNull(), caption:User-ID, logging:true */
  protected $lanuser;
  /** type:String, size:255, logging:short */
  protected $password;
  /** type:boolean */
  protected $nomail;
  /** type:integer, foreign_model:nutzer, foreign_key:id, foreign_value:kurz, caption:Nutzer, validate:notNull(), logging:true */
  protected $fk_nutzer;

  /** type:integer, foreign_model:objekt, foreign_key:id, foreign_value:kurz, caption:Objekt, validate:notNull(), logging:true */
  protected $fk_objekt;
  /** type:integer, foreign_model:bauteil, foreign_key:id, foreign_value:kurz, caption:Bauteil,  logging:true */
  protected $fk_bauteil;

  /** type:String, size:255, logging:true */
  protected $stockwerk;

  /** type:boolean, caption:Controller */
  protected $cont;

  /** type:integer, foreign_model:servicecenter, foreign_key:id, foreign_value:kurz, caption:ServiceCenter, logging:true */
  protected $fk_servicecenter;
  /** type:integer, foreign_model:dienstleister, foreign_key:id, foreign_value:kurz, caption:Dienstleister, logging:true */
  protected $fk_dienstleister;
  /** type:date, caption:gueltig_ab, validate:notNull(), value:01.01.2011, logging:true */
  protected $gueltigab;
  /** type:date, caption:gueltig_bis, validate:notNull(), value:31.12.2999, logging:true */
  protected $gueltigbis;

  /** type:text */
  protected $history;

}
?>
