<?PHP


class c_errmail extends yadev4php_controller
{
    
    
    public $mailresult;
    public $info;
    public $serverURL;
    public $betreff;
    public $recode;
    
    /* ---------------------------------------------------------------------------
    ----------------------------------------------------------------------------*/
    public function init()
    {
    }

    public function _testmail()
    {

     echo($this->sendMail('michael.wallner@boku.ac.at', 
                              "Neues Ticket: Test ", 
                              nl2br(htmlspecialchars("Es wurde <eins> Ihnen ein Ticket zugewiese äüö")),
                              'noreply@eldie.at', 
                              'office@michael-wallner.at', 
                              false));



    }    

    /* ---------------------------------------------------------------------------
    ----------------------------------------------------------------------------*/
    public function main()
    {
    }

    /* ---------------------------------------------------------------------------
    ----------------------------------------------------------------------------*/
    public function save()
    {
    }

    private function sendMail($to, $subject = 'Neue Aufgabe:', $mailtext = 'Siehe Link', $from, $cc = '', $a = false)
    {

        GLOBAL $config_email;
        GLOBAL $config_upload;
        GLOBAL $application;


        // in der Testumgebung keine E-Mails an Dritte
        if ( $application == 'test' ) { 
           $to = "office@michael-wallner.at";
           $cc = '';
        }


        $mail = new PHPMailer(true); // the true param means it will throw exceptions on errors, which we need to catch
        $mail->IsSMTP(); // telling the class to use SMTP
        
        try {
            // $mail->CharSet   = "utf-8";
            // $mail->Encoding = "8bit";
            $mail->Host      = $config_email['Server']; //"mail.michael-wallner.at"; // SMTP server
            $mail->SMTPDebug = 0; // enables SMTP debug information (for testing)
            $mail->SMTPAuth  = $config_email['SMTPAuth']; //true;				  // enable SMTP authentication
            $mail->Username  = $config_email['Username']; // SMTP account username
            $mail->Password  = $config_email['Password']; // SMTP account password

            if (is_string($from))
                $mail->SetFrom($from);
            else
                $mail->SetFrom($from->email, $from->vorname . ' ' . $from->zuname);

            if (is_string($to))
                $mail->AddAddress($to);
            else
                $mail->AddAddress($to->email, $to->vorname . ' ' . $to->zuname);

            if (is_string($cc)) {
                if ($cc != '')
                    $mail->AddBCC($cc);
            }
            else
                $mail->AddBCC($cc->email, $cc->vorname . ' ' . $cc->zuname);

            $mail->WordWrap = 50;                               // set word wrap
            $mail->Priority = 1; 
            $mail->IsHTML(true);
            $mail->Subject = $subject;
            $mailtext = iconv("UTF-8", "ISO-8859-1//TRANSLIT", $mailtext);
            $mail->MsgHTML($mailtext);
            $mail->CharSet="ISO-8859-1";

            if ($a) {
                if ($this->bora() == 1)
                    $fn = "Bestellschein_" . $this->ticket->lnummer . ".pdf";
                else
                    $fn = "Auftragsschein_" . $this->ticket->lnummer . ".pdf";
                
                $mail->AddAttachment(getAppPath()."mail/VERHALTENSREGELN_FREMDFIRMEN.pdf");
                $mail->AddStringAttachment($this->createPDFAttachment($this->ticket->id), $fn);
            } //$a
            
            $mail->Send();
            
            return 'E-Mail wurde gesendet';
        }
        catch (phpmailerException $e) {
            return 'Fehler:' . $e->errorMessage(); //Pretty error messages from PHPMailer
        }
        catch (Exception $e) {
            return 'Fehler:' . $e->getMessage(); //Boring error messages from anything else!
        }
    }
    
    
    
  
}

?>
