<?PHP

//if ($_SESSION['rolle_id'] != 1) die();

class c_sql extends yadev4php_controller {

  public $_db;       // Database Class
  public $_result;
  
  public function init() {
  
    GLOBAL $config_db;
    $dbd = $config_db["Driver"];
    $this->_db = new $dbd();
    $this->_db->open();

  }
  
  
  public function main() {

    $this->views['view_1'] = new yadev4php_view();
    $this->views['view_1']->loadTPL("s_head.tpl","head");
    $this->views['view_1']->loadTPL("s_bottom.tpl","bottom");
    $this->views['view_1']->loadTPL("s_sql.tpl","template");
    $this->views['view_1']->sendTPL();

  }


  public function save() {

    $this->views['view_1'] = new yadev4php_view();
    $this->views['view_1']->loadTPL("s_head.tpl","head");
    $this->views['view_1']->loadTPL("s_bottom.tpl","bottom");
    $this->views['view_1']->loadTPL("s_sql.tpl","template");
    $this->views['view_1']->sendTPL();
    
    $pagesize = (INT)$_POST['npagesize'];
    $page = (INT)$_POST['npage'];

    echo "<hr>Start Abfrage:".microtime(true);

    $this->_result = $this->_db->select($_POST['ssql']);
    echo "<hr>Ende Abfrage:".microtime(true);
    if (!$this->_result === false) {
      $this->_result = $this->_result->fetchAll(PDO::FETCH_ASSOC);
      echo "<hr>Ende fetchAll:".microtime(true)." - Datens&auml;tze:".count($this->_result)."<hr>";
      if ($pagesize != 0) {
        $dArray = array_chunk($this->_result,$pagesize,false);
        $this->_result = $dArray[$page];
      echo "Ende Paging:".microtime(true)." - Datens&auml;tze:".count($this->_result)."<hr>";
      }
      
      if (count($this->_result) > 0) {
        $i = 1;
        echo "<table border=1><tr><th>row</th>";
        foreach ($this->_result[0] as $key => $col) {
          echo "<th>".$key."</th>";
        }
        echo "</tr>";
        foreach ($this->_result as $row) {
          echo "<tr><td>".$i++."</td>";
          foreach ($row as $col) {
            echo "<td>".$col."</td>";
          }
          echo "</tr>";
          flush();
          ob_flush();
        }
        echo "</table>";
      }
      else
        echo "Keine Daten vorhanden";
    }
    else {
      echo (implode(" - ",$this->_db->errorInfo()));
    }

    echo "<hr>Ende:".microtime(true)."<br>";
  }


  public function _test() {
  
    echo "<hr>Start:".microtime(true);

    $page = (INT)$_GET['page'];
    $pagesize = (INT)$_GET['pagesize'];
    
    // Templates laden...

    // alle bentigten Modelle laden...
    $this->add_model("aufgabe","",false);
    $this->add_model("status","",false);
    $this->add_model('abteilung','geber',false);
    $this->add_model('abteilung','nehmer',false);
    $this->add_model('einstufung',false);
    $this->add_model('prozess','',false);
    $this->add_model('produkt','',false);
    $this->add_model('herkunft','',false);
    $this->add_model("myjoin","join",false,false);

    // Join laden...
    $this->join->addModel($this->aufgabe);
    $this->join->addModel($this->status,
                          "aufgabe.status = status.id",
                          "inner join");
    $this->join->addModel($this->geber,
                          "aufgabe.auftraggeber = geber.id",
                          "inner join");
    $this->join->addModel($this->nehmer,
                          "aufgabe.auftragnehmer = nehmer.id",
                          "inner join");
    $this->join->addModel($this->einstufung,
                          "aufgabe.einstufung = einstufung.id",
                          "left join");
    $this->join->addModel($this->prozess,
                          "aufgabe.prozess = prozess.id",
                          "left join");
    $this->join->addModel($this->produkt,
                          "aufgabe.produkt = produkt.id",
                          "left join");
    $this->join->addModel($this->herkunft,
                          "aufgabe.herkunft = herkunft.id",
                          "left join");


    echo "<hr>Start Abfrage:".microtime(true);
    $this->join->loadModelByWhere("art=1","aufgabe.id",$page,$pagesize);
    echo "<hr>Ende Abfrage:".microtime(true)."<hr>";

      if (count($this->join->_result) > 0) {
        $i = 1;
        echo "<table border=1><tr><th>row</th>";
        foreach ($this->join->_result[0] as $key => $col) {
          echo "<th>".$key."</th>";
        }
        echo "</tr>";
        foreach ($this->join->_result as $row) {
          echo "<tr><td>".$i++."</td>";
          foreach ($row as $col) {
            echo "<td>".$col."</td>";
          }
          echo "</tr>";
          flush();
          ob_flush();
        }
        echo "</table>";
      }
      else
        echo "Keine Daten vorhanden";
    echo "<hr>Ende:".microtime(true);

  }

   public function _testmail()
    {

     echo($this->sendMail('michael.wallner@boku.ac.at', 
                              "Neues Ticket: Test ", 
                              nl2br(htmlspecialchars("Es wurde <eins> Ihnen ein Ticket zugewiese äüö")),
                              'noreply@eldie.at', 
                              'office@michael-wallner.at', 
                              false));



    }    
    

  
  public function _test2() {

    echo "<hr>Start:".microtime(true);

    $page = (INT)$_GET['page'];
    $pagesize = (INT)$_GET['pagesize'];

    // Templates laden...

    // alle bentigten Modelle laden...
    $this->add_model("aufgabe","",false,false);
    $this->add_model("status","",false,false);
    $this->add_model('abteilung','geber',false,false);
    $this->add_model('abteilung','nehmer',false,false);
    $this->add_model('einstufung','',false,false);
    $this->add_model('prozess','',false,false);
    $this->add_model('produkt','',false,false);
    $this->add_model('herkunft','',false,false);
    $this->add_model("myjoin","join",false,false);

    // Join laden...
    $this->join->addModel($this->aufgabe);
    $this->join->addModel($this->status,
                          "aufgabe.status = status.id",
                          "inner join");
    $this->join->addModel($this->geber,
                          "aufgabe.auftraggeber = geber.id",
                          "inner join");
    $this->join->addModel($this->nehmer,
                          "aufgabe.auftragnehmer = nehmer.id",
                          "inner join");
    $this->join->addModel($this->einstufung,
                          "aufgabe.einstufung = einstufung.id",
                          "left join");
    $this->join->addModel($this->prozess,
                          "aufgabe.prozess = prozess.id",
                          "left join");
    $this->join->addModel($this->produkt,
                          "aufgabe.produkt = produkt.id",
                          "left join");
    $this->join->addModel($this->herkunft,
                          "aufgabe.herkunft = herkunft.id",
                          "left join");


    echo "<hr>Start Abfrage:".microtime(true);
    $this->join->loadModelByWhere("art=1","aufgabe.id",$page,$pagesize);
    echo "<hr>Ende Abfrage:".microtime(true)."<hr>";

    $model = $this->join;

    $this->add_model("storage","",false,false);
    $this->storage->loadModelByWhere("iduser=".$_SESSION['userid']." and store='liste_aufgaben' and param='Column_Order'");

    if ($this->storage->valid)
      $cOrder = $this->storage->value;
    else
      $cOrder = "";
    $this->storage->loadModelByWhere("iduser=".$_SESSION['userid']." and store='liste_aufgaben' and param='Column_Visibility'");
    if ($this->storage->valid)
      $cVisibility = $this->storage->value;
    else
      $cVisibility = "";

    $r = "<table class=scrollable cellpadding=5 cellspacing=0 border=0>\n".
         "<thead>\n".
         "  <tr>\n";

echo $r;
flush();
ob_flush();
    
    $this->column_title='Nr.:Gruppen:Ersteller:AG:Auftragnehmer:Erstellt am:Ge&auml;ndert am:Termin:Prognose:Erledigung:Status:Titel:QU:UM:AS:RE:RI:Herkunft:Einstufung:Prozess:Produkt:Beschreibung:Anmerkungen:BA-Intern';
    $this->column_field='aufgabe_x_lnummer:aufgabe_x_groupid:aufgabe_x_ersteller:geber_x_kurz:nehmer_x_kurz:aufgabe_x_erstell_datum:aufgabe_x_letzte_aenderung:aufgabe_x_termin:aufgabe_x_prognose:aufgabe_x_erledigung:status_x_kurz:aufgabe_x_titel:aufgabe_x_z_qu:aufgabe_x_z_um:aufgabe_x_z_as:aufgabe_x_z_re:aufgabe_x_z_ri:herkunft_x_kurz:einstufung_x_kurz:prozess_x_kurz:produkt_x_kurz:aufgabe_x_besch:aufgabe_x_anmerkung:aufgabe_x_intern';
    $this->link='../main/?';
    $this->color='farbe';
    $this->linkID='aufgabe_x_id';
    
    
    $aTitle = split(":",$this->column_title);
    $aField = split(":",$this->column_field);

    $aField = array_combine($aTitle,$aField);
    $aTitle = array_combine($aTitle,$aTitle);


    $aTitleSession = split(":",$cOrder);
    $aDisplay = split(":",$cVisibility);

    $aDisplay = array_combine($aTitleSession,$aDisplay);


    $c = array_intersect($aTitleSession,$aTitle);
    $d = array_diff($aTitle,$aTitleSession);
    $e = array_merge($c,$d);

    foreach ($e as $t) {
      $title = $aTitle[$t];
      $r .= "    <td nowrap style='display: ".$aDisplay[$t]."'><b>".$title."</b>&nbsp;&nbsp;&nbsp;</td>\n";
    }

    $r .= "</tr>\n".
          "</thead>\n".
          "<tbody>\n";

echo $r;
flush();
ob_flush();

    $qs = "?id=";
    if (strpos($this->link,"?") != -1) $qs= "&id=";

    $color = $this->color;
    if ($model) {
      foreach ($model as $row) {
        if ($color !="" )
          $r = "<tr style='color:".$row->$color.";'>\n";
        else
          $r = "<tr>\n";

        $linkID = $this->linkID;
        $first = true;
        foreach ($e as $f) {
          $field = $aField[$f];
          if ($color != "")
            if ($first) {
              $first = false;
              $r .= "<td nowrap style='display: ".$aDisplay[$f]."'><a href='".$this->link.$qs.$row->$linkID."' class=link onmouseout='st_tooltip_hide()' onmouseover='st_tooltip_show(event)' style='color:".$row->$color.";'>".htmlentities($row->$field)."</a></td>\n";
            }
            else
              $r .= "<td nowrap style='display: ".$aDisplay[$f]."'><a href='".$this->link.$qs.$row->$linkID."' class=link style='color:".$row->$color.";'>".htmlentities($row->$field)."</a></td>\n";
          else
            $r .= "<td nowrap style='display: ".$aDisplay[$f]."'><a href='".$this->link.$qs.$row->$linkID."' class=link>".htmlentities($row->$field)."</a></td>\n";
        }
        $r .= "</tr>\n";
        echo $r;
        flush();
        ob_flush();
      }
    }

    $r = "</tbody>\n".
          "</table>\n";

//    $r .= "<script>start();</script>\n\n";

echo $r;

  }
  

}

?>
