<?PHP
class multiSelect extends yadev4php_control {

   public $size = 20;
   public $sourceModel;
   public $sourceID = "id";
   public $sourceField;
   
   public $targetModel;
   public $targetID;
   
   public $fKey;
   

   private function getSource() {
     $a = array();
     $b = split(',',$this->sourceField);
     $model = $this->sourceModel;
     $model = getController()->models[$model];
     $id = $this->sourceID;
     foreach ($model as $row) {
       $val = "";
       foreach ($b as $field) {
         $val .= " ".$row->$field;
       }
       $val = trim($val);
       $a[$row->$id] = $val;
     }
     return $a;
   }
   
   
   private function getTarget($s) {
     $a = array();
     $model = $this->targetModel;
     $model = getController()->models[$model];
     $id = $this->targetID;
     foreach ($model as $row) {
       $a[$row->$id] = $s[$row->$id];
     }
     return $a;
   }
   
   
   public function getHTML() {
   
      $s = $this->getSource();
      $t = $this->getTarget($s);
      
      $s = array_diff($s,$t);
      
   
      $r = "<table border=0>\n".
           "<tr>\n".
           "<td>\n".
           " <SELECT id='".$this->_name."_source[]' size='".$this->size."' multiple ondblclick='".$this->_name."_var.copyToTarget();'>";

      foreach ($s as $key => $value) {
        $r .= "<option value='".$key."'>".$value."</option>\n";
      }

      $r .= " </select>\n".
           "</td><td>\n".
           "  <a href='javascript:".$this->_name."_var.copyToTarget();'>&gt;&gt;&gt;</a>\n".
           "  <br><br>\n".
           "  <a href='javascript:".$this->_name."_var.copyToSource();'>&lt;&lt;&lt;</a>\n".
           "</td><td>\n".
           " <SELECT name='".$this->_name."_target[]' id='".$this->_name."_target[]' size='".$this->size."' multiple ondblclick='".$this->_name."_var.copyToSource();'>\n";

      foreach ($t as $key => $value) {
        $r .= "<option value='".$key."'>".$value."</option>\n";
      }

      $r .= " </select>\n".
           "</td>\n".
           "</tr>\n".
           "</table>\n\n".
           "<script>var dummy = new multiSelect('".$this->_name."');</script>\n";

     return $r;
   }
   
   
  public function readInput($filter = "", $mode= "P") {
    $f = str_replace("[]","",$this->_name);
    $f .= "_target";
    if ($mode == "R")
      $wert = $_REQUEST[$f];
    elseif ($mode == "G")
      $wert = $_GET[$f];
    else
      $wert = $_POST[$f];


    if (is_array($wert)) {
      if ($filter != "") {
        foreach($wert as $i) {
          $i = $filter($i);
        }
      }
    }
    else {
      $wert = array();
    }
    $this->input = $wert;
  }

   
   

   public function getJS() {
     $r = array('multiselect' => 'multiselect');
     return $r;
   }

//   public function getInitJS() {
//     $n = str_replace('[]','',$this->_name);
//
//     $s = "";
//     $model = $this->model;
//     $model = getController()->models[$model];
//     $field = $this->field;
//     foreach ($model as $row) {
//       $s .= "'".$row->$field."',";
//     }
//     $s = trim($s,",");


//     $r = array($n => "\n<script>\nvar as_".$n." = new AutoSuggestControl(document.getElementById('".$this->_name."'), new localSuggestions([".$s."]));</script>\n");

//     return $r;
//   }
   
//   public function getCSS() {
//     $r = array('autosuggest' => 'autosuggest');
//     return $r;
//   }
   
   
}
?>

