// ---------------------------------------------------------------------------
// this script is copyright (c) 2011 by Michael Wallner
// http://www.michael-wallner.at
//
// you must not use this script with other web pages
// you must not remove this copyright note!
//
// Sie drfen dieses Script nicht in anderen Webseiten verwenden
// Sie drfen diesen Copyright Hinweis nicht entfernen!
// ---------------------------------------------------------------------------

var g_break = false;
var pageSize = 20;

var SORT_COLUMN_INDEX;
var SORT_DIR;
var tdHead;
var tdBody;
var divBody;
var divDrag;
var divTool;

st_addEvent(window, 'load', start);

var URI = unescape(window.location.href);
URI = URI.substring(0, URI.length - 1);
var fileN1 = URI.indexOf("/") + 1;
var fileN2 = URI.length;
var file_name = URI.substring(fileN1, fileN2);
fileN2 = file_name.lastIndexOf("/");
file_name = file_name.substring(0, fileN2);


function start() {
    var tables = document.getElementsByTagName('table');
    for (var i = 0; i < tables.length; i++) {
        thisTable = tables[i];
        if (thisTable.className.indexOf('scrollable') != -1) {
            makeScrollable(thisTable);
        }
    }
    bt_scroll_vertical2();

}



function st_resize() {
    if (self == top) {
        window.scrollTo(0, 0);

        var t = st_findAbsolutePosition(document.getElementById('hDIV'))[1];
        var h = st_windowHeight() - t - 40
        if (h < 40) h = 40;
        document.getElementById('tBodyDIV').style.height = h + 'px';
        var w = st_windowWidth() - 30;
        if (w < 100) w = 100;
        document.getElementById('tBodyDIV').style.width = w + 'px';
        document.getElementById('tHeadDIV').style.width = w + 'px';
    } else {
        var w = st_windowWidth() - 40;
        if (w < 100) w = 100;
        document.getElementById('tBodyDIV').style.width = w + 'px';
        document.getElementById('tHeadDIV').style.width = w + 'px';
    }
}


function st_windowHeight() {
    win = window;
    if (win.innerHeight) {
        return win.innerHeight;
    } else {
        if (win.document.documentElement && win.document.documentElement.clientHeight) {
            return win.document.documentElement.clientHeight;
        }
        return win.document.body.offsetHeight;
    }
}


function st_windowWidth() {
    win = window;
    if (win.innerWidth) {
        return win.innerWidth;
    } else {
        if (win.document.documentElement && win.document.documentElement.clientWidth) {
            return win.document.documentElement.clientWidth;
        }
        return win.document.body.offsetWidth;
    }
}


function st_format_save(ids) {
    // Speichere die aktuelle Formatierung am Server
    var f = "";
    var d = "";
    var z = "";
    t = document.getElementById('thead');
    td = t.getElementsByTagName('TD');
    for (var x = 0; x < td.length; x++) {
        if (td[x].hasChildNodes()) {
            f = f + td[x].firstChild.innerHTML + ":";
            d = d + td[x].style.display + ":";
            z = z + td[x].style.width + ':';
        }
    }

    f = encodeURIComponent(f.substr(0, f.length - 1));
    d = encodeURI(d.substr(0, d.length - 1));
    s = encodeURI(SORT_COLUMN_INDEX + ':' + SORT_DIR);
    z = encodeURI(z.substr(0, z.length - 1));

    AjaxRequest.get({
        'url': '../../c_save/_save/?id=' + ids + '&f=' + f + '&d=' + d + '&s=' + s + '&z=' + z,
        'onSuccess': function (req) {
            alert(req.responseText);
        },
        'onError': function (req) {
            alert('Error!\nStatusText=' + req.statusText + '\nContents=' + req.responseText);
        },
        'timeout': 40000,
        'onTimeout': function (req) {
            alert("Timeout-Fehler");
        }
    });

}


var st_md;
var st_drag;
var st_x1;
var st_obj_drag;
var st_obj_width;
var st_drag_mode = 3;
var st_col1;
var st_col2;
var cpage;
var loging = '';



function fadeIn(el, duration, ziel) {

    var step = 1 / duration * 10,
        opacity = 0;
    if (document.all) step = 1 / (duration / 50);
    (function () {
        if (opacity >= ziel) {
            return;
        }
        opacity += step;
        oie = opacity * 100;
        if (document.all) el.style.filter = "Alpha(opacity=" + oie + ")";
        else el.style.opacity = opacity;
        setTimeout(arguments.callee, 10);
    })();

}

function fadeOut(el, duration, von) {

    var step = 1 / duration * 10,
        opacity = von;
    if (document.all) step = 1 / (duration / 50);
    (function () {
        if (opacity <= 0) {
            el.style.display = 'none';
            el.style.visibility = 'hidden';
            el.src = "about:blank";
            return;
        }
        opacity -= step;
        oie = opacity * 100;
        if (document.all) el.style.filter = "Alpha(opacity=" + oie + ")";
        else el.style.opacity = opacity;
        setTimeout(arguments.callee, 10);
    })();

}


function fi() {
    var tdiv1 = document.getElementById('st_edit1');
    tdiv1.style.visibility = 'visible';
    tdiv1.style.display = 'block';
    if (!document.all) fadeIn(tdiv1, 100, 1);
}


function st_change_cell(edit_obj, feld, wert) {
    var oTR = getParent(edit_obj, 'TR');

    var t = document.getElementById('thead');
    var td = t.getElementsByTagName('TD');
    for (var x = 0; x < td.length; x++) {
        if (td[x].hasChildNodes()) {
            if (td[x].firstChild.innerHTML == feld) {
                oTR.getElementsByTagName('TD')[x].innerHTML = wert;
                x = td.length;
            }
        }
    }
}

function st_ajax_inline(href, wert) {
    url = href.replace(/main/, "_inline_save");
    url = url + "&wert=" + encodeURIComponent(wert);


    AjaxRequest.get({
        'url': url,
        'onSuccess': function (req) {
            var tdiv = document.getElementById('st_iedit');
            tdiv.style.visibility = 'hidden';
            var oTR = getParent(edit_obj, 'TR');
            oTR.style.color = 'violet';
            var aa = eval('(' + req.responseText + ')');
            //var aa = JSON.parse(req.responseText);
            for (var o in aa) {
                if (o == 'alert') alert(aa[o]);
                else st_change_cell(edit_obj, o, aa[o]);
            }

        },
        'onError': function (req) {
            var tdiv = document.getElementById('st_iedit');
            tdiv.style.visibility = 'hidden';
            alert('Error!\nStatusText=' + req.statusText + '\nContents=' + req.responseText);
        },
        'timeout': 40000,
        'onTimeout': function (req) {
            var tdiv = document.getElementById('st_iedit');
            tdiv.style.visibility = 'hidden';
            alert("Timeout-Fehler");
        }
    });
}


var edit_obj;
var edit_href;


function close_inline_p(submit, value) {
    if (submit) st_ajax_inline(edit_href, value);
    else {
        var tdiv = document.getElementById('st_iedit');

        tdiv.style.width = '350px';
        tdiv.style.height = '20px';
        tdiv.style.visibility = 'hidden';
    }

}

function edit_inline(obj, href) {
    edit_obj = obj;
    edit_href = href;

    var tdiv;
    if (!document.getElementById('st_iedit')) {
        tdiv = document.createElement("iframe");
        tdiv.setAttribute('scrolling', 'no', 0);
        tdiv.className = "cInlineEdit";
        tdiv.id = "st_iedit";
        document.body.appendChild(tdiv);
    } else {
        tdiv = document.getElementById('st_iedit');
    }

    pos = st_findAbsolutePosition(obj);
    tdiv.style.left = (pos[0] + 0) + "px";
    tdiv.style.top = (pos[1] + 0) + "px";

    url = href.replace(/main/, "_inline");

    tdiv.src = url;
    tdiv.style.visibility = 'hidden';
    return false;
}


function edit_resize() {
    var tdiv = document.getElementById('st_edit');
    var tdiv1 = document.getElementById('st_edit1');
    tdiv.style.top = Math.max(document.body.scrollTop, document.documentElement.scrollTop) + 'px';
    tdiv.style.left = Math.max(document.body.scrollLeft, document.documentElement.scrollLeft) + 'px';
    var brSize = getBrowserSize();
    var bodyWidth = brSize[0];
    var bodyHeight = brSize[1];
    tdiv.style.width = bodyWidth + 'px';
    tdiv.style.height = bodyHeight + 'px';
    tdiv1.style.top = (Math.max(document.body.scrollTop, document.documentElement.scrollTop) + 100) + 'px';
    tdiv1.style.width = (bodyWidth - 40) + 'px';
    tdiv1.style.height = (bodyHeight - 140) + 'px';
}


function edit(id) {

    if (document.getElementById('st_iedit')) document.getElementById('st_iedit').style.visibility = 'hidden';

    if (self == top) {
        var tdiv = document.getElementById('st_edit');
        var tdiv1 = document.getElementById('st_edit1');
        tdiv.style.top = Math.max(document.body.scrollTop, document.documentElement.scrollTop) + 'px';
        tdiv.style.left = Math.max(document.body.scrollLeft, document.documentElement.scrollLeft) + 'px';
        var brSize = getBrowserSize();
        var bodyWidth = brSize[0];
        var bodyHeight = brSize[1];
        tdiv.style.width = bodyWidth + 'px';
        tdiv.style.height = bodyHeight + 'px';
        tdiv1.style.top = (Math.max(document.body.scrollTop, document.documentElement.scrollTop) + 100) + 'px';
        tdiv1.style.width = (bodyWidth - 40) + 'px';
        tdiv1.style.height = (bodyHeight - 140) + 'px';
        tdiv.style.visibility = 'visible';
        tdiv.style.display = 'block';
        fadeIn(tdiv, 100, 0.4);
        tdiv1.contentWindow.document.body.innerHTML = "";
        tdiv1.src = document.location.pathname + id + '&nohead=true';
        return false;
    } else {
        document.location.href = document.location.pathname + id + '&nohead=true';
        return false;
    }

}

function edit_close() {
    var tdiv = document.getElementById('st_edit');
    var tdiv1 = document.getElementById('st_edit1');
    if (document.all) {
        tdiv1.style.visibility = 'hidden';
        tdiv1.style.display = 'none';
        tdiv1.src = "about:blank";
    } else {
        fadeOut(tdiv1, 100, 1);
    }
    fadeOut(tdiv, 100, 0.4);
}


var tooltiptimer;

function st_tooltip(href) {
    window.clearTimeout(tooltiptimer);
    tooltiptimer = window.setTimeout("st_tooltip2('" + href + "')", 500);
}


function st_tooltip2(href) {
    url = href.replace(/main/, "_tooltip");
    AjaxRequest.get({
        'url': url,
        'onSuccess': function (req) {
            var tdiv = document.getElementById('st_tooltip');
            tdiv.innerHTML = req.responseText;
            tdiv.style.visibility = 'visible';
            //var the_top = parseFloat(tdiv.style.top) - parseFloat(tdiv.offsetHeight);
            //tdiv.style.top = the_top+"px";
        },
        'onError': function (req) {
            document.getElementById('st_tooltip').innerHTML = 'Error!\nStatusText=' + req.statusText + '\nContents=' + req.responseText;
        },
        'timeout': 40000,
        'onTimeout': function (req) {
            document.getElementById('st_tooltip').innerHTML = "Timeout-Fehler";
        }
    });
}


function st_tooltip_show(obj, href) {

    pos = st_findAbsolutePosition(obj);
    var tdiv;
    if (!document.getElementById('st_tooltip')) {
        tdiv = document.createElement("div");
        tdiv.className = "cToolTip";
        tdiv.id = "st_tooltip";
        document.body.appendChild(tdiv);
    } else {
        tdiv = document.getElementById('st_tooltip');
    }

    tdiv.style.left = (pos[0] + 30) + "px";
    tdiv.style.top = (pos[1] - 10) + "px";

    tdiv.innerHTML = ""; //href;
    //tdiv.style.visibility = 'visible';
    st_tooltip(href);
}


function st_tooltip_hide() {
    window.clearTimeout(tooltiptimer);
    tdiv = document.getElementById('st_tooltip');
    tdiv.style.visibility = 'hidden';
    tdiv.innerHTML = "";
}


function st_findAbsolutePosition(obj) {
    var curleft = curtop = 0;
    var dh;
    dh = document.getElementById('tHeadDIV').scrollLeft;
    dv = document.getElementById('tBodyDIV').scrollTop;
    if (obj.offsetParent) {
        do {
            curleft += obj.offsetLeft;
            curtop += obj.offsetTop;
        } while (obj = obj.offsetParent);
    }
    return [curleft - dh, curtop - dv];
}


function st_mousedown(e) {
    if (window.event) {
        obj = window.event.srcElement;
        e = window.event;
    } else {
        obj = e.target;
    }
    if (obj.tagName != "TD") obj = getParent(obj, 'TD');


    if (e.pageX || e.pageY) {
        posx = e.pageX;
        posy = e.pageY;
    } else if (e.clientX || e.clientY) {
        posx = e.clientX + document.body.scrollLeft + document.documentElement.scrollLeft;
        posy = e.clientY + document.body.scrollTop + document.documentElement.scrollTop;
    }

    p = getParent(obj, 'TR');
    pc = p.getElementsByTagName('TD');
    for (var x = 0; x < pc.length; x++) {
        if (pc[x] == obj) st_col1 = x;
    }
    var pos;
    pos = st_findAbsolutePosition(obj);
    st_obj_width = parseFloat(obj.style.width);

    if (posx > (pos[0] + st_obj_width - 10)) {
        st_drag_mode = 0;
        document.body.style.cursor = 'col-resize';
    } else {
        st_drag_mode = 1;
        document.body.style.cursor = 'pointer';

    }

    divDrag.innerHTML = obj.innerHTML;
    st_md = true;
    st_obj_drag = obj;
    st_x1 = e.screenX;
}


function st_mousemove(e) {

    if (window.event) {
        e = window.event;
    }

    if (st_md && (!st_drag)) {
        if (Math.abs(e.screenX - st_x1) > 5 + (st_drag_mode * 5)) {
            st_drag = true;
            if (st_drag_mode == 0) document.body.style.cursor = 'col-resize'; //'pointer';
            else {
                document.body.style.cursor = 'pointer';
                divDrag.style.visibility = 'visible';
            }
        }
    }
    if (st_md && st_drag && st_drag_mode == 1) {
        var posx = 0;
        var posy = 0;
        if (e.pageX || e.pageY) {
            posx = e.pageX;
            posy = e.pageY;
        } else if (e.clientX || e.clientY) {
            posx = e.clientX + document.body.scrollLeft + document.documentElement.scrollLeft;
            posy = e.clientY + document.body.scrollTop + document.documentElement.scrollTop;
        }
        divDrag.style.left = (posx + 10) + "px";
        divDrag.style.top = (posy + 20) + "px";
    }
    if (st_md && st_drag && st_drag_mode == 0) {
        var posx = 0;
        var posy = 0;
        if (e.pageX || e.pageY) {
            posx = e.pageX;
            posy = e.pageY;
        } else if (e.clientX || e.clientY) {
            posx = e.clientX + document.body.scrollLeft + document.documentElement.scrollLeft;
            posy = e.clientY + document.body.scrollTop + document.documentElement.scrollTop;
        }
        st_obj_drag.style.width = Math.max(st_obj_width + e.screenX - st_x1, 15) + 'px';
        bt_fix_width_all();

        //divDrag.style.left = (posx+10)+"px";
        //divDrag.style.top = (posy+20)+"px";
    }
}

function st_mouseup(e) {
    if (window.event) {
        obj = window.event.srcElement;
    } else {
        obj = e.target;
    }
    if (obj.tagName != "TD") obj = getParent(obj, 'TD');
    st_md = false;
    divDrag.style.visibility = 'hidden';

    p = getParent(obj, 'TR');
    pc = p.getElementsByTagName('TD');
    for (var x = 0; x < pc.length; x++) {
        if (pc[x] == obj) st_col2 = x;
    }

    if (st_col1 != st_col2 && st_drag_mode == 1) {
        obj.parentNode.insertBefore(st_obj_drag, obj);

        t = document.getElementById('tfilter');
        tr = t.getElementsByTagName('TR');
        for (var x = 0; x < tr.length; x++) {
            td = tr[x].getElementsByTagName('TD');
            tr[x].insertBefore(td[st_col1], td[st_col2]);
        }
    } else {
        if (st_drag == false) dblClickHeader(e);
    }

    document.body.style.cursor = 'auto';
    if (st_drag && st_drag_mode == 0)
      bt_fix_width_all();
    var obj;
    obj = document.getElementById('tBodyDIV');
    obj.previousSibling.scrollLeft = obj.scrollLeft;
    st_drag = false;

}

function st_del_mouseup(e) {
    // Drag auf Button zum lschen einer Spalte
    if (st_drag) {
        st_md = false;
        st_drag = false;
        divDrag.style.visibility = 'hidden';
        document.body.style.cursor = 'auto';

        st_obj_drag.style.display = 'none';

        t = document.getElementById('tfilter');
        tr = t.getElementsByTagName('TR');
        for (var x = 0; x < tr.length; x++) {
            td = tr[x].getElementsByTagName('TD');
            td[st_col1].style.display = 'none';
        }
        //st_calc_width();
    }
}

function st_show_columns() {
    t = document.getElementById('thead');
    td = t.getElementsByTagName('TD');
    for (var x = 0; x < td.length; x++) {
        td[x].style.display = '';
    }
    // #### Alle Divs aus Body lschen und anzeige neu laden.......

    //st_calc_width();
}

function st_d_mouseup(e) {
    st_md = false;
    if (st_drag && st_drag_mode == 0)
    //st_calc_width();
    st_drag = false;
    divDrag.style.visibility = 'hidden';
    document.body.style.cursor = 'auto';
}

function st_addEvent(element, eventType, func) {
    if (element.addEventListener) {
        element.addEventListener(eventType, func, false);
        return true;
    } else if (element.attachEvent) {
        var r = element.attachEvent('on' + eventType, func);
        return r;
    } else {
        return false;
    }
}

function scrollEvent(e) {
    var obj;
    if (window.event) {
        obj = window.event.srcElement;
    } else {
        obj = e.target;
    }
    obj.previousSibling.scrollLeft = obj.scrollLeft;
    bt_scroll_vertical();
    tsetCookie("SCROLLLEFT",obj.scrollLeft,'default');
    tsetCookie("SCROLLTOP",obj.scrollTop,'default');
    if (document.getElementById('st_iedit')) {
        if (document.getElementById('st_iedit').style.visibility != 'hidden') {
            pos = st_findAbsolutePosition(edit_obj);
            document.getElementById('st_iedit').style.left = (pos[0] + 0) + "px";
            document.getElementById('st_iedit').style.top = (pos[1] + 0) + "px";
        }
    }
}

  
function bt_fix_width_all() {
    bt_scroll_vertical2()
}
  
function bt_fix_width(div) {
    // Breite der Datenspalten an die berschriften anpassen....
    //document.getElementById('bDIV').style.width = '90000px';

    var obj1 = document.getElementById('bDIV');
    var thead = document.getElementById('thead');
    var tdHead = thead.getElementsByTagName('td');
    var tBody = div.getElementsByTagName("table")[0];

    if (tBody) {
      tBody.style.width = (parseFloat(thead.offsetWidth)) + 'px';
      obj1.style.width = (parseFloat(thead.offsetWidth)) + 'px';  

      var trBody = tBody.getElementsByTagName("tr");

      if (trBody) {
        tdBody = trBody[0].getElementsByTagName('td');
        for (var i = 0; i < tdHead.length; i++) {
            if (tdHead[i].display != "none") {
                w = parseFloat(tdHead[i].offsetWidth);
                if (w > 4) tdBody[i].style.width = (parseFloat(tdHead[i].offsetWidth) - 4) + 'px';
            }
         }
      }
      tBody.style.width = (parseFloat(thead.offsetWidth)) + 'px';
    }
}

var numRecords;

function bt_ajax(href, p) {
    //lade die zwei aktuellen Seiten nach....
    var cpage = p;
    p++;

    if (href.indexOf('?') < 0) {
        href = href + '?';
    }

    url = href + '&page=' + p;
    window.clearTimeout(bgLoadTimer);

    AjaxRequest.get({
        'url': url,
        'onSuccess': function (req) {

            //bgLoadTimer = window.setTimeout("bgLoad()",250);

            var responseText = req.responseText;

            var s1 = responseText.indexOf('<!-- numRecords=');
            var s2 = responseText.indexOf('-->', s1);
            var s = responseText.slice(s1 + 16, s2);

            if (s1 > -1) {
                var obj = document.getElementById('bDIV');
                numRecords = Number(s);
                obj.style.height = (20 * (numRecords)) + 'px';

                document.getElementById('anzahl').innerHTML = s;

                var p1 = responseText.indexOf('<table class=scrollable');
                var p2 = responseText.indexOf('</table', p1);
                var t = document.getElementById('tfilter');
                var d = responseText.slice(p1, p2) + '</table>';

                document.getElementById('big_div_' + cpage).innerHTML = d;
                bt_fix_width(document.getElementById('big_div_' + cpage));
            }
        },
        'onError': function (req) {
            alert('Error!\nStatusText=' + req.statusText + '\nContents=' + req.responseText);
        },
        'timeout': 40000,
        'onTimeout': function (req) {
            alert("Timeout-Fehler\nDaten konnten nicht geladen werden");
        }
    });
}


var bgLoadTimer;

function bgLoad() {

  var page = 0;
  var fertig = true;

  var pageGeladen = 0;

  var maxPage = Math.floor(numRecords / pageSize);

  while (page < maxPage+1) {
    obj = document.getElementById('tBodyDIV');
    obj1 = document.getElementById('bDIV');

    if (!document.getElementById('big_div_' + page)) {
      if (fertig) {
        var tdiv = document.createElement("div");
        tdiv.className = "bBig";
        tdiv.id = "big_div_" + page;
        tdiv.innerHTML = "<img src=big_load.gif border=0>";
        tdiv.style.top = (page * 21 * pageSize) + 'px';
        tdiv.style.height = (21 * pageSize) + 'px';
        tdiv.style.width = '120px';
        tdiv.style.visibility = 'visible';
        obj1.appendChild(tdiv);
        bt_ajax(document.location.href, page);
        //line = numRecords + 1;
        fertig = false;
      }
    }
    else {
      if (document.getElementById('big_div_' + page).getElementsByTagName('table').length > 0)
        pageGeladen++;
      else
        fertig = false;
    }
    page++;
  }
  if (numRecords <= pageGeladen*pageSize) 
    document.getElementById('anzahl').innerHTML = numRecords
  else
    document.getElementById('anzahl').innerHTML = numRecords+" ("+pageGeladen*pageSize+") ";

}


var scrollTimer;

function bt_scroll_vertical() {
    window.clearTimeout(scrollTimer);
    scrollTimer = window.setTimeout("bt_scroll_vertical2()", 500);
}

function bt_scroll_vertical2() {

    obj = document.getElementById('tBodyDIV');
    obj1 = document.getElementById('bDIV');
    var top = obj.scrollTop;
    var line = Math.floor(top / 21);
    var page = Math.floor(line / pageSize);
    for (var i=0; i<6; i++) {
      if (!document.getElementById('big_div_' + page)) {
        var tdiv = document.createElement("div");
        tdiv.className = "bBig";
        tdiv.id = "big_div_" + page;
        tdiv.innerHTML = "<img src=big_load.gif border=0>";
        tdiv.style.top = (page * 21 * pageSize) + 'px';
        tdiv.style.height = (21 * pageSize) + 'px';
        tdiv.style.width = '120px';
        tdiv.style.visibility = 'visible';
        obj1.appendChild(tdiv);
        bt_ajax(document.location.href, page);
      } else {
        bt_fix_width(document.getElementById('big_div_'+page));
   
      }
      page++;
    }

    
 
}

function st_save_scroll() {
    //try {
    //obj = document.getElementById('tBodyDIV');
    //tsetCookie("SCROLLLEFT",obj.scrollLeft,'default');
    //tsetCookie("SCROLLTOP",obj.scrollTop,'default');
    //}
    //catch(err) {
    //}
}


function get_cellIndex(obj) {

    if (document.all && document.getElementById) {
        var r = obj.parentNode;
        for (var x = 0; x < r.childNodes.length; x++) {
            if (r.childNodes[x] == obj) return x;
        }
        return -1;
    } else return obj.cellIndex;
}



function dblClickHeader(e) {
    var obj;
    var dir;
    if (window.event) {
        obj = window.event.srcElement;
    } else {
        obj = e.target;
    }
    if (obj.tagName != "TD") obj = getParent(obj, 'TD');

    if (obj.className == 't_sortup') {
        dir = 'down';
        obj.className = 't_sortdown';
    } else {
        obj.className = 't_sortup';
        dir = 'up';
    }


    obj1 = getParent(obj, 'TR');
    obj1 = obj1.getElementsByTagName('TD');
    for (var i = 0; i < obj1.length; i++) {
        if (!(obj1[i] == obj)) {
            obj1[i].className = 'td_border';
        }
    }
    // Sortierung entsprechend ndern!..........
    return false;
}



function tsetCookie(name, value, expire) {
    name = file_name + name;
    if (expire == 'default') {
        var today = new Date();
        var expire = new Date();
        expire.setTime(today.getTime() + 1000 * 60 * 60 * 24 * 365);
    }
    document.cookie = name + "=" + escape(value) + ((expire == null) ? "" : ("; expires=" + expire.toGMTString()));
}

function tgetCookie(name) {
    name = file_name + name;
    var search = name + "=";
    if (document.cookie.length > 0) {
        offset = document.cookie.indexOf(search);
        if (offset != -1) {
            offset += search.length;
            end = document.cookie.indexOf(";", offset);
            if (end == -1) end = document.cookie.length;
            return unescape(document.cookie.substring(offset, end));
        }
    }
}







function getParent(el, pTagName) {
    if (el == null) return null;
    else if (el.nodeType == 1 && el.tagName.toLowerCase() == pTagName.toLowerCase()) return el;
    else return getParent(el.parentNode, pTagName);
}



function onSelect(e) {
    var obj;
    if (window.event) {
        obj = window.event.srcElement;
    } else {
        obj = e.target;
    }
    if (obj.nodeName == 'TD') return false;
    if (obj.nodeName == 'B') return false;
    return true;
}


function getBrowserSize() {
    var bodyWidth = document.documentElement.clientWidth;
    var bodyHeight = document.documentElement.clientHeight;
    if (self.innerHeight) { // all except Explorer
        bodyWidth = self.innerWidth;
        bodyHeight = self.innerHeight;
    } else if (document.documentElement && document.documentElement.clientHeight) {
        // Explorer 6 Strict Mode
        bodyWidth = document.documentElement.clientWidth;
        bodyHeight = document.documentElement.clientHeight;
    } else if (document.body) {
        // other Explorers
        bodyWidth = document.body.clientWidth;
        bodyHeight = document.body.clientHeight;
    }
    return [bodyWidth, bodyHeight];
}


function makeScrollable(table) {

    if (!document.getElementById('st_edit')) {
        tdiv = document.createElement("div");
        tdiv.className = "bLoad";
        tdiv.id = "st_edit";
        tdiv.style.visibility = 'hidden';

        tdiv1 = document.createElement("iframe");
        tdiv1.className = "ciFrame";
        tdiv1.id = "st_edit1";
        tdiv1.style.display = 'none';
        document.body.appendChild(tdiv);
        document.body.appendChild(tdiv1);
    }


    // ### ?????????
    tdiv.style.top = Math.max(document.body.scrollTop, document.documentElement.scrollTop) + 'px';
    tdiv.style.left = Math.max(document.body.scrollLeft, document.documentElement.scrollLeft) + 'px';

    var brSize = getBrowserSize();
    var bodyWidth = brSize[0];
    var bodyHeight = brSize[1];
    tdiv.style.width = bodyWidth + 'px';
    tdiv.style.height = bodyHeight + 'px';

    st_addEvent(document, 'selectstart', onSelect);

    divDrag = document.createElement('DIV');
    divDrag.className = 'div_drag';
    document.body.appendChild(divDrag);

    var tBodyDIV = document.createElement('DIV');
    tBodyDIV.className = 'div_tbody';
    tBodyDIV.id = 'tBodyDIV';

    table.parentNode.insertBefore(tBodyDIV, table.nextSibling);


    var tHeadDIV = document.createElement('DIV');
    tHeadDIV.style.MozUserSelect = "none";
    tHeadDIV.className = 'div_thead';
    tHeadDIV.id = 'tHeadDIV';

    table.parentNode.insertBefore(tHeadDIV, table.nextSibling);

    var tHeadDIV2 = document.createElement('DIV');
    tHeadDIV2.id = 'hDIV';
    tHeadDIV2.style.width = '90000px';
    tHeadDIV.appendChild(tHeadDIV2);

    var tHead = document.createElement('table');
    tHead.setAttribute('cellSpacing', '0px');
    tHead.setAttribute('cellPadding', '1px');
    tHead.setClassName = "scrollable";
    tHead.style.tableLayout = 'fixed';
    tHead.style.width = '30px';
    tHead.id = "thead";
    tHeadDIV2.appendChild(tHead);
    tHead.appendChild(table.getElementsByTagName('thead')[0]);

    var tBodyDIV2 = document.createElement('DIV');
    tBodyDIV2.className = 'test';
    tBodyDIV2.style.width = '90000px';
    divBody = tBodyDIV2;
    tBodyDIV2.id = 'bDIV';
    tBodyDIV.appendChild(tBodyDIV2);

    tHeadDIV.style.height = (parseFloat(tHead.offsetHeight) == 0 ? '26px' : parseFloat(tHead.offsetHeight) + 'px');

    st_addEvent(tBodyDIV, 'scroll', scrollEvent);

    var trHead = tHead.getElementsByTagName('tr');
    trHead = trHead[trHead.length - 1];
    trHead.className = 'tr_odd';
    tdHead = trHead.getElementsByTagName('td');
    for (var i = 0; i < tdHead.length; i++) {
        st_addEvent(tdHead[i], 'mousedown', st_mousedown);
        st_addEvent(tdHead[i], 'mouseup', st_mouseup);
        st_addEvent(document.body, 'mousemove', st_mousemove);
        st_addEvent(document.body, 'mouseup', st_d_mouseup);
        st_addEvent(document.getElementById('delcolumn'), 'mouseup', st_del_mouseup);
        st_addEvent(window, 'unload', st_save_scroll);
    }
    st_addEvent(window, 'resize', st_resize);
    document.getElementsByTagName('body')[0].style.overflow = 'hidden';
    st_resize();
    dummy = (table.parentNode).removeChild(table);
	

    var divSearch = document.createElement('DIV');
    divSearch.className = 'cDivSearch';
	divSearch.id = 'searchDIV';
    pos = st_findAbsolutePosition(document.getElementById('tHeadDIV'));
    divSearch.style.left = (pos[0] + 0) + "px";
    divSearch.style.top = (pos[1] + 0) + "px";
	divSearch.style.width = document.getElementById('tHeadDIV').style.width;
	divSearch.style.maxHeight = (parseFloat(document.getElementById('tBodyDIV').style.height) + parseFloat(document.getElementById('tHeadDIV').style.height)) + 'px';
	if (document.getElementById('suche'))
          divSearch.appendChild(document.getElementById('suche'));
	document.body.appendChild(divSearch);
	sOpenClose();

	
}


function sOpenClose () {
 
  var d = document.getElementById('searchDIV');

  
  if (d.style.display != 'none') {
	d.style.display = 'none';
  }
  else {
	d.style.display = ''
  }

}
