// ---------------------------------------------------------------------------
// this script is copyright (c) 2007 by Michael Wallner
// http://www.wallner-software.com
//
// you must not use this script with other web pages
// you must not remove this copyright note!
//
// Sie drfen dieses Script nicht in anderen Webseiten verwenden
// Sie drfen diesen Copyright Hinweis nicht entfernen!
// ---------------------------------------------------------------------------

// clientseitiges JS-Object zum mhc_multiSelect Control
function multiSelect(name) {
  this.name = name;
  this.copyToTarget = copyToTarget;
  this.copyToSource = copyToSource;
  
  fromList = document.getElementById(this.name + '_source[]');
  toList   = document.getElementById(this.name + '_target[]');
  if (fromList.offsetWidth > toList.offsetWidth)
    toList.style.width = Number(fromList.offsetWidth) + 'px';
  else
    fromList.style.width = Number(toList.offsetWidth) + 'px';

  this.sortList = sortList;
  this.selAll = selAll;

  function selAll() {
    toSel = document.getElementById(this.name + '_target[]');
    for (i=0; i<toSel.options.length; i++) {
      if (toSel.options[i].value != 'temp') {
        toSel.options[i].selected = true;
      }
    }
  }
  
  function sortList() {
    toSort = document.getElementById(this.name + '_source[]');
    sortListE(toSort);
    toSort = document.getElementById(this.name + '_target[]');
    sortListE(toSort);
  }
  
  function sortListE(toSort) {
    flag = true;
    while (flag && (toSort.options.length > 1)) {
      flag = false;
      for (i=1; i<toSort.options.length; i++) {
        if (toSort.options[i-1].text > toSort.options[i].text) {
          txt = toSort.options[i].text;
          val = toSort.options[i].value;
          toSort.options[i].text = toSort.options[i-1].text;
          toSort.options[i].value = toSort.options[i-1].value;
          toSort.options[i-1].text = txt;
          toSort.options[i-1].value = val;
          flag = true;
        }
      }
    }
  }

  function copyToTarget() {
    copyToList(this.name + '_source[]', this.name + '_target[]');
    this.sortList();
  }
  
  function copyToSource() {
    copyToList(this.name + '_target[]', this.name + '_source[]');
    this.sortList();
  }
  
  function copyToList(from, to) {
    fromList = document.getElementById(from);
    toList   = document.getElementById(to);
    
    // 'standard' Eintrag 'temp' zu erst lschen
    if (toList.options.length > 0 && toList.options[0].value == 'temp') {
      toList.options.length = 0;
    }
    for (i=0; i<fromList.options.length; i++) {
      var current = fromList.options[i];
      if (current.selected) {
        // 'standard' Wert 'temp' kann nicht kopiert werden!
        if (current.value != 'temp') {
          // Eintrag in Ziel-Liste einfgen
          txt = current.text;
          val = current.value;
          toList.options[toList.options.length] = new Option(txt,val);
          // ohne erneute Zuweisung von val hat es nicht funktioniert ;-)
          toList.options[toList.options.length-1].value = val;
          // Eintrag aus Quell-Liste lschen
          fromList.options[i] = null;
          i--;
        }
      }
    }
    if (fromList.offsetWidth > toList.offsetWidth)
      toList.style.width = Number(fromList.offsetWidth) + 'px';
    else
      fromList.style.width = Number(toList.offsetWidth) + 'px';
  }
     
  this.v = this.name + "_var";   // global var of 'this'
  eval(this.v + "=this");
  
  ms_controls[ms_controls.length] = this.name;
  
  if (document.addEventListener) {
    document.getElementById(document.getElementById(this.name+'_target[]').form.id).addEventListener('submit',ms_onSubmit,false);
  }
  else {
    document.getElementById(document.getElementById(this.name+'_target[]').form.id).attachEvent('onsubmit',ms_onSubmit);
  }



  return this
}

ms_controls = new Array();

function ms_onSubmit() {
  for (c=0;c<ms_controls.length;c++) {
    toSel = document.getElementById(ms_controls[c] + '_target[]');
    for (i=0; i<toSel.options.length; i++) {
      if (toSel.options[i].value != 'temp') {
        toSel.options[i].selected = true;
      }
    }
  }
}




// - EOF -
