<?PHP
class yadev4php_control {

  private $_name;                       // Name des Objektes
  private $phpid;
  private $count;
  
  private $value;                       // aktueller 'Wert' des Controls
  private $input;                       // User Eingabe nach POST
  private $validate = Array();          // Validierungsfunktionen
  private $cssclass;                    // CSS Klasse des Controls
  
  private $model = "";                       // Verknpfung zu einem Model
  private $field = "";                       // und einem Feld
  private $v1 = '';


  private $latin1UTF8;
  

  public function property_exists($dt) {
    $r = false;
    $cls = get_class($this);
    while ($cls != "") {
      if (property_exists($cls,$dt)) {
        $r = true;
      }
      $cls = get_parent_class($cls);
    }
    return $r;
  }
  
  //
  // Setzte den Wert einer Variablen
  //
  private function __set($dt, $vl) {
    if (!$this->property_exists($dt))
     throw new Exception("Cannot assign values to undefined property:".$dt,1);

    // suche eine Methode in diesem Objekt fr das Setzten der Variable
    if (method_exists($this,"onset_".$dt)) {
       $m = "onset_".$dt;
       $vl = $this->$m($vl);
    }
    if (is_array($this->$dt)) {
       array_push($this->$dt,$vl);
    }
    else
      $this->$dt = $vl;
  }

  //
  // Lese den Wert einer Variablen
  //
  public function __get($dt) {
    if (!$this->property_exists($dt))
      throw new Exception("Cannot get values from undefined property ".$dt,2);

    // suche eine Methode in diesem Objekt fr das Lesen der Variable
    $val = $this->$dt;
    
    if (method_exists($this,"onget_".$dt)) {
       $m = "onget_".$dt;
       $val = $this->$m($val);
    }
    return $val;
  }


  public function onget_value($val) {
    $model = $this->model;
    $field = $this->field;
    if ($this->model != "") {
      if (getController()->models[$model]->$field != "") {
        return getController()->models[$model]->$field;
      }
      else
        return $val;
    }
    else
      return $val;
  }


  public function readInput($filter = "", $mode= "P") {
    $f = str_replace("[]","",$this->_name);
    if ($mode == "R")
      $wert = $_REQUEST[$f];
    elseif ($mode == "G")
      $wert = (isset($_GET[$f]) ? $_GET[$f] : '');
    else
      $wert = (isset($_POST[$f]) ? $_POST[$f] : '');

    if (get_magic_quotes_gpc()) {
      if (is_array($wert)) {
        foreach($wert as $i) {
          $i = stripslashes($i);
        }
      }
      else {
        $wert = stripslashes($wert);
      }
    }

// speed test
//    if (is_array($wert)) {
//      foreach($wert as $key=>$i) {
//        $i = $this->latin1UTF8->mixed_to_latin1($i);
//      }
//    }
//    else {
//      $wert = $this->latin1UTF8->mixed_to_latin1($wert);
//    }

//echo $wert."<hr>";


    if (is_array($wert)) {
      if ($filter != "") {
        foreach($wert as $i) {
          $i = $filter($i);
        }
      }
    }
    else {
      if ($filter != "") {
        $wert = $filter($wert);
      }
    }
    
    $model = $this->model;
    $field = $this->field;
    if ($this->model != "" && $this->field != 'history') {
      if (is_array($wert))
        getController()->models[$model]->$field = array_pop($wert);
      else
        getController()->models[$model]->$field = $wert;
    }
    $this->input = $wert;
    if (is_array($wert))
      $this->value = array_pop($wert);
    else
      $this->value = $wert;
  }


  
  
  public function getJS() {
     $a = Array();
     return $a;
   }

   public function getInitJS() {
     $a = Array();
     return $a;
   }

  public function getCSS() {
     $a = Array();
     return $a;
   }


  public function __construct($n) {
    $this->_name = $n;
	$this->count = 0;
//    $this->latin1UTF8 = new latin1UTF8();    // speed test
    getController()->controls[$n] = $this;
  }
  

}
?>
