<?PHP
class c_login extends yadev4php_controller {


  public function init() {




//echo "Derzeit wegen Wartungsarbeiten nicht verfgbar!";
//die();

	ob_start();
	
	$this->add_model("anwender","",false,false);
	$this->add_model("objekt","",false,false);
	$this->add_model("nutzer","",false,false);
	$this->add_model("servicecenter","",false,false);
	$this->add_model("dienstleister","",false,false);
	$this->add_model("servicecenter","sc_objekt",false,false);

	$this->views['view_1'] = new yadev4php_view();
	$this->views['view_1']->loadTPL("head.tpl","head");
	$this->views['view_1']->loadTPL("bottom.tpl","bottom");
	$this->views['view_1']->loadTPL("login.tpl");

  }
  

  public function main() {

	$_SESSION['userid'] = "";
	$_SESSION['darf_admin'] = false;
	$_SESSION['darf_anlegen'] = true;
	$_SESSION['darf_sc'] = false;
	$_SESSION['darf_dl'] = false;
	$_SESSION['anwender_name'] = "";
	$this->views['view_1']->sendTPL();

  }
  
  
  public function save() {
  
	if ($_SERVER['REQUEST_METHOD'] != "POST") {
	  $this->main();
	  die();
	}

	$this->views['view_1']->readInput();


        $loginOK = false;



	$this->anwender->loadModelByWhere("lanuser like '".$this->controls['lanuser']->input."'");

	if ($this->anwender->valid) {
	  if ($this->anwender->password == $this->controls['password']->input) {
		  $loginOK = true;
          }
	}

	if ($loginOK == true) {
	  
		$this->anwender->history = 'Login: '.date('d.m.Y H:i:s',time())."\r\n".
					   'From: '.$_SERVER['REMOTE_ADDR'].'-'.GetHostByName($_SERVER['REMOTE_ADDR'])."\r\n".
					   $this->anwender->history;
		$this->anwender->updateModel();


                $this->nutzer->loadModelByWhere('id = ' . (int) $this->anwender->fk_nutzer);
                $this->objekt->loadModelByWhere('id = ' . (int) $this->anwender->fk_objekt);
                $this->servicecenter->loadModelByWhere('id = ' . (int) $this->anwender->fk_servicecenter);
                $this->dienstleister->loadModelByWhere('id = ' . (int) $this->anwender->fk_dienstleister);
                $this->sc_objekt->loadModelByWhere('id = ' . (int) $this->objekt->fk_servicecenter);                

                // Anwender
		$_SESSION['userid'] = $this->anwender->id;
		$_SESSION['anwender_id'] = $this->anwender->id;
		$_SESSION['anwender_userid'] = $this->anwender->lanuser;
		$_SESSION['anwender_name'] = $this->anwender->zuname." ".$this->anwender->vorname;
		$_SESSION['anwender_zuname'] = $this->anwender->zuname;
		$_SESSION['anwender_vorname'] = $this->anwender->vorname;
		$_SESSION['anwender_email'] = $this->anwender->email;
		$_SESSION['anwender_telefon'] = $this->anwender->telefon;
		$_SESSION['ersteller'] = $this->anwender->id;

                // Nutzer des Anwenders
                $_SESSION['nutzer_id'] = $this->nutzer->id;
                $_SESSION['nutzer_kurz'] = $this->nutzer->kurz;

                // Objekt des Anwenders
                $_SESSION['objekt_id'] = $this->objekt->id;
                $_SESSION['objekt_kurz'] = $this->objekt->kurz;
                $_SESSION['objekt_prefix'] = $this->objekt->prefix;
                $_SESSION['objekt_servicecenter'] = $this->objekt->fk_servicecenter;
                $_SESSION['sevicecenter_auto'] = (int) $this->sc_objekt->fk_dienstleister;

                // ServiceCenter Berechtigung
                $_SESSION['servicecenter_id'] = $this->anwender->fk_servicecenter;
                $_SESSION['servicecenter'] = $this->servicecenter->kurz;
                if ( (int) $this->anwender->fk_servicecenter > 0 ) $_SESSION['darf_admin'] = true;


                // Dienstleister Berechtigung
                $_SESSION['dienstleister_id'] = $this->anwender->fk_dienstleister;
                $_SESSION['dienstleister'] = $this->dienstleister->kurz;
                
		$this->views['view_1']->loadTPL("login_ok.tpl");

		if ($_GET['from'] != "") {
		  ob_clean();
		  redir($_GET['from']);
		}
	 
	}
	
	ob_flush();

        if ($loginOK == false) 
          $this->views['view_1']->message .= "Fehler: Falsche Anmeldedaten!<br><br><br>[OK]"; 
	
	$this->views['view_1']->sendTPL();

  }
  
  


  public function getAccount() {

	$_SESSION['userid'] = "";
	$_SESSION['darf_admin'] = false;
	$_SESSION['darf_anlegen'] = true;
	$_SESSION['darf_sc'] = false;
	$_SESSION['darf_dl'] = false;
	$_SESSION['anwender_name'] = "";
	$this->views['view_1']->loadTPL("getaccount.tpl");
	$this->views['view_1']->sendTPL();

  }


  public function send() {
  
	if ($_SERVER['REQUEST_METHOD'] != "POST") {
	  $this->main();
	  die();
	}

	$this->views['view_1']->loadTPL("getaccount.tpl");
	$this->views['view_1']->readInput();

	$this->anwender->loadModelByWhere("email like '".$this->controls['email']->input."'");

        if ( $this->anwender->valid ) {
           $this->views['view_1']->message .= $this->_mailAccount()."<br><br>";
        }
        else {
           $this->views['view_1']->message .= "Fehler: Unbekannte E-Mail Adresse<br><br>[ok]";
        }

	$this->views['view_1']->loadTPL("login.tpl");
	$this->views['view_1']->sendTPL();
  }        

  private function _mailAccount() {

        GLOBAL $config_email;
        GLOBAL $config_upload;
        GLOBAL $application;


        $to = $this->anwender->email;
        $from = "noreply@eldie.at";
        $cc = "office@michael-wallner.at";    

        // in der Testumgebung keine E-Mails an Dritte
        if ( $application == 'test' ) { 
           $to = "office@michael-wallner.at";
           $cc = '';
        }

        $mail = new PHPMailer(true); // the true param means it will throw exceptions on errors, which we need to catch
        $mail->IsSMTP(); // telling the class to use SMTP
        
        try {
            $mail->Host      = $config_email['Server']; //"mail.michael-wallner.at"; // SMTP server
            $mail->SMTPDebug = 0; // enables SMTP debug information (for testing)
            $mail->SMTPAuth  = $config_email['SMTPAuth']; //true;				  // enable SMTP authentication
            $mail->Username  = $config_email['Username']; // SMTP account username
            $mail->Password  = $config_email['Password']; // SMTP account password


            $mail->SetFrom($from);
            $mail->AddAddress($to); 
            if ($cc != '')  
              $mail->AddBCC($cc);
            
            $mail->Subject = "Ihre Anfrage an ehl.eldie.at";
            $mail->MsgHTML("Ihre Zugangsdaten lauten:<br><br>User-ID: ".$this->anwender->lanuser."<br>Passwort: ".$this->anwender->password."<br><br>Es wird empfohlen das Passwort nach der Anmeldung umgehend zu &auml;ndern. Rufen Sie dazu den Men&uuml;punkt 'Einstellungen' auf.<br><br><br><br>EHL - Immobilien Management Service Center <a href=http://ehl.eldie.at>ehl.eldie.at</a><br><hr><span style='font-size:80%;'>(c) 2015 - <a href='http://www.michael-wallner.at'>Michael Wallner - Unternehmensberatung</a></span>");
            
            $mail->Send();
            
            return 'E-Mail wurde gesendet';
        }
        catch (phpmailerException $e) {
            return 'Fehler:' . $e->errorMessage(); //Pretty error messages from PHPMailer
        }
        catch (Exception $e) {
            return 'Fehler:' . $e->getMessage(); //Boring error messages from anything else!
        }



  }



 

}
?>
