
function localSuggestions(state) {
    this.states = state;
}


localSuggestions.prototype.requestSuggestions = function (oAutoSuggestControl /*:AutoSuggestControl*/,
                                                          bTypeAhead /*:boolean*/) {
    var aSuggestions = [];
    var sTextboxValue = oAutoSuggestControl.textbox.value;
    
    if (sTextboxValue.length > 0){
    
        //convert value in textbox to lowercase
        var sTextboxValueLC = sTextboxValue.toLowerCase();

        //search for matching states
        for (var i=0; i < this.states.length; i++) { 

            //convert state name to lowercase
            var sStateLC = this.states[i].toLowerCase();
           
            //compare the lowercase versions for case-insensitive comparison
//            if (sStateLC.indexOf(sTextboxValueLC) == 0) {
            if (sStateLC.indexOf(sTextboxValueLC) != -1) {
                //add a suggestion using what's already in the textbox to begin it                
                //aSuggestions.push(sTextboxValue + this.states[i].substring(sTextboxValue.length));
                aSuggestions.push(this.states[i]);
            } 
       }
       
    }
    else {
        for (var i=0; i < this.states.length; i++) {
                aSuggestions.push(this.states[i]);
        }
    }

    //provide suggestions to the control
    oAutoSuggestControl.autosuggest(aSuggestions, false); //bTypeAhead);
    if (aSuggestions.length == 0)
      oAutoSuggestControl.valid = false;
    else
      oAutoSuggestControl.valid = true;
};
