<?

class yadev4php_view {

  public $head;
  public $bottom;
  
  public $template;
  public $controls = Array();

  public $js = Array();
  public $initjs = Array();
  public $css = Array();


  public $message;
  public $title;

  private $tpl;
  

 function getJS() {
   foreach ($this->controls as $control) {
     foreach($control->getJS() as $js) {
       $this->js[$js] = $js.".js";
     }
   }
   $r = '';
   foreach ($this->js as $js) {
     $r = $r."<script type='text/javascript' src='".$js."'></script>\n";
   }
   return $r;
 }
 
 function getInitJS() {
   foreach ($this->controls as $control) {
     foreach($control->getInitJS() as $key => $js) {
       $this->initjs[$key] = $js;
     }
   }
   $r = '';
   foreach ($this->initjs as $js) {
     $r = $r.$js;
   }
   return $r;
 }
 
 
 function getCSS() {
   foreach ($this->controls as $control) {
     foreach($control->getCSS() as $css) {
       $this->css[$css] = $css.".css";
     }
   }
   $r = '';
   foreach ($this->css as $css) {
     $r = $r."<link rel='stylesheet' type='text/css' href='".$css."' />\n";
   }
   return $r;
 }


   

 function loadTPL($tpl, $what = 'template', $save = '') {

    if (file_exists(getAppPath()."views/".$tpl)) {
      $this->tpl = file_get_contents(getAppPath()."views/".$tpl);
    }
    elseif (file_exists(getBasisPath()."system/views/".$tpl)) {
      $this->tpl = file_get_contents(getBasisPath()."system/views/".$tpl);
    }
    else {
      echo "Template '".$tpl."' not found!";
      die();
    }
    
    // 'haupt' Template sofort mit eval barbeiten
    if ($what == "template") {
     ob_start();
     eval ("?>".$this->tpl."<?");
     $c = ob_get_contents();
     ob_end_clean();
     $this->tpl = "\n".$c;
    }
    
    if ($save != '') {
      //$fp = fopen(getAppPath()."views/g_".$save.'.tpl', 'w');
      //fwrite($fp, $this->tpl);
      //fclose($fp);
    }

    // Template Controls ermitteln
    $er = $this->findControls($this->tpl);
    
    // Control Objekte aus Template anlegen
    $this->$what = $er["tpl"];
    foreach ($er as $key => $value) {
      if ($key != "tpl") {
        
//        echo $key."<hr>";
//        var_dump($value);
        if ($_GET['debug'] != '') echo 'Key: '.$key.' - Class:'.$value['class'].' - ID:'.$value['id'].'<hr>';
        $this->controls[$key] = new $value["class"]($value['id']);
        foreach ($value as $pkey => $parm) {
          if ($pkey != "id" && $pkey != "class") {
            if (is_array($this->controls[$key]->$pkey)) {
              foreach ($parm as $wert) {
                $this->controls[$key]->$pkey = $wert;
              }
            }
            else
              $this->controls[$key]->$pkey = $parm;
          }
        }
      }
    }
  }
  
  function getTokens(
        $string,
        $offset = 0,
        $defaultTokenName = 'class',
        $groupDelimiters = '\'"',
        $groupNameDelimiter = '=')
    {

    if ($offset >= strlen($string)) {
        //echo "offset out of range";
        return false;
    }

    $spaces = " \t\n\r";   // space characters

    // add group delimiters to spaces...
    $groupSpaces = $spaces . $groupNameDelimiter;
    $delimiters = $groupSpaces . $groupDelimiters;

    //var_dump($groupSpaces);

    $string = ltrim(substr($string, $offset), $groupSpaces);
    $token_strings = array();

    //echo "String is : " . $string . "\n";

    // 1. split all tokens...
    while ($offset < strlen($string)) {
        $lastOffset = $offset;
        $escaped = false;

        if (false !== strpos($groupDelimiters, $char = $string[$offset])) {
            $groupChar = $char;
        } else {
            $groupChar = null;
        }

        if (null !== $groupChar) {
            while (($offset < strlen($string)-1) && (($groupChar !== ($char = $string[++$offset])) || $escaped)) {
                //$offset++;
                $escaped = ('\\' === $char);
            }
            $offset++;
            //echo "*** Grouped : " . substr($string, $lastOffset, $offset - $lastOffset) . "\n";
        } else {
            while (($offset < strlen($string)) && ((false === strpos($delimiters, $char = $string[$offset])) || $escaped)) {
                $offset++;
                $escaped = ('\\' === $char);
            }
            //echo "*** Non-group : " . substr($string, $lastOffset, $offset - $lastOffset) . "\n";
        }
        //skip spaces...
        while (($offset < strlen($string)) && ((false !== strpos($groupSpaces, $char = $string[$offset])) || $escaped)) {
            $offset++;
            $escaped = ('\\' === $char);
        }

        $token_strings[] = substr($string, $lastOffset, $offset - $lastOffset);
//echo "Next token = '" . end($token_strings) . "'\n<br>";
    }

    $tokens = array();
    $tokenName = null;
    foreach ($token_strings as $token_str) {
        // clean $token_str
        $token_str = trim(stripslashes($token_str), $spaces);
        $str_value = html_entity_decode(trim($token_str, $delimiters),ENT_QUOTES);
        //$token_str = trim(($token_str), $spaces);
//echo "$token_str - ".substr($token_str,-3,2)."<hr>";
        //$e = '';
        //if (substr($token_str,-3,1) == "\\") $e = substr($token_str,-2,1); 
        //$str_value = stripslashes(trim($token_str, $delimiters)).$e;
//echo "<hr>".$str_value."<hr>";
        switch (strtolower($str_value)) {
            case 'true': $str_value = true; break;
            case 'false': $str_value = false; break;
            default: break;
        }

        // is it a token name?
        if ($groupNameDelimiter === substr($token_str, -1, 1)) {
            if (!empty($tokenName)) {
                $tokens[$tokenName] = '';
            }
            $tokenName = trim($token_str, $delimiters);
        } else {
            if (!empty($tokenName)) {
                if (isset($tokens[$tokenName])) {
                    $tokens[$tokenName] = array(
                        $tokens[$tokenName],
                        stripslashes($str_value)
                    );
                } else {
                    $tokens[$tokenName] = stripslashes($str_value);
                }
                $tokenName = null;
            } elseif (empty($defaultTokenName)) {
                $tokens[] = trim($token_str, $delimiters);;
            } else {
                if (isset($tokens[$defaultTokenName])) {
                    $tokens[$defaultTokenName] = array(
                        $tokens[$defaultTokenName],
                        $str_value
                    );
                } else {
                    $tokens[$defaultTokenName] = $str_value;
                }
            }
        }
    }
    if (!empty($tokenName)) {
        $tokens[$tokenName] = '';
    }

    return $tokens;
  }

  function findControls($tpl) {
    $com = "";

    // finde ersten <com: Eintrag
    $a = strpos($tpl,"<com:");
    while (!$a === false) {

      // ende finden
      $b = strpos($tpl,">",$a);

      // control definition ausschneiden
      $com = trim(substr($tpl,$a+5,$b-$a-5));

      // zerlegen und in Array speichern
      $com = $this->getTokens($com);

      // wenn phpid nicht angegebn war, dann =id
      if (!isset($com['phpid'])) {
        $com['phpid'] = (isset($com['id']) ? $com['id'] : '');
      }
      if ($com['phpid'] == "") {
        $com['phpid'] = md5(rand(1,1000));
        $com['id'] = $com['phpid'];
      }
	  
      if (isset($com['count'])) $com['phpid'] .= $com['count'];
	  
      // control parameter in Array speichern
      $r[$com['phpid']] = $com;

      // ende (</com>) suchen und gesamten Bereich durch PHP aufruf ersetzten...
      $c = strpos($tpl,"</com>",$b);

      $tpl = substr_replace($tpl,"<? \$this->sendControl('".$com['phpid']."', \$v1); ?>",$a,$c-$a+6);

      // nchstes <com: object suchen
      $a = strpos($tpl,"<com:");
    }
    $r["tpl"] = $tpl;
//    echo "<pre>";
//    var_dump($r);
    return $r;
  }
  
  
  function sendControl($control, $v1 = array('')) {
    $v = array('#v1#','#v2#','#v3#','#v4#','#v5#');
    echo str_replace($v,$v1,$this->controls[$control]->getHTML());
  }




  function sendTPL() {
     eval (' $v1=array(); ?>'.$this->head.'<?');
     eval (' $v1=array(); ?>'.$this->template.'<?');
     if ($this->message != "") {
       if (strpos($this->message,'Fehler:') === false) {
          echo '<div id=tpl_meldung style="position:absolute; background-color:green; left:50%; top:40%; width:400px; height:200px; margin-top:-100px; margin-left:-200px; border-style:none; color:white;" >';
       } else {
          echo '<div id=tpl_meldung style="position:absolute; background-color:red; left:50%; top:40%; width:400px; height:200px; margin-top:-100px; margin-left:-200px; border-style:none; color:white;" >';
       }
       echo '<table border=0 width=400px height=200px cellspacing=0 cellpadding=0><tr><td style="vertical-align:middle; text-align:center; font-weight:bold;" onClick="document.getElementById(\'tpl_meldung\').style.visibility=\'hidden\';">'.$this->message.'</td></tr></table></div>';
       echo "<script type='text/javascript'>";
       if (strpos($this->message,'Fehler:') === false) {
         echo 'setTimeout("document.getElementById(\"tpl_meldung\").style.visibility=\"hidden\"",2500);';
       }
       echo "</script>";        
     }
     eval (' $v1=array(); ?>'.$this->bottom.'<?');
  }
  
  function getTPL() {

    ob_start();

      eval ("?>".$this->head."<?");
      eval ("?>".$this->template."<?");
      if ($this->message != "") {
        echo '<div id=tpl_meldung style="position:absolute; background-image: url(./meldung.jpeg); left:50%; top:40%; width:200px; height:100px; margin-top:-50px; margin-left:-100px; border-style:snone; color:black">';
        echo '<table border=0 width=200px height=100px cellspacing=0 cellpadding=0><tr><td style="vertical-align:middle; text-align:center; font-weight:bold;">'.$this->message.'</td></tr></table></div>';
        echo "<script type='text/javascript'>";
        echo 'setTimeout("document.getElementById(\"tpl_meldung\").style.visibility=\"hidden\"",2500);';
        echo "</script>";
      }
      eval ("?>".$this->bottom."<?");

    return ob_get_clean();

  }
  
  function readInput() {
     foreach ($this->controls as $control) {
       $control->readInput();
     }
  }
}

?>
